﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using System.IO;
using System.Configuration;

/*============================================================================
  File:     Program.cs
 
  Summary:  This program implements insert a new row that uses a 
            Filestream-enabled column in SQL Server 2008

  Date:     August 2008

  SQL Server Version: 10.0.1600.22 (RTM)
------------------------------------------------------------------------------
  Written by Bob Beauchemin, SQLskills.com

  For more scripts and sample code, check out http://www.SQLskills.com

  This script is intended only as a supplement to SQL Server Jumpstart program.
  
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/

namespace FileStreamInsert
{
    class Program
    {

        static void Main(string[] args)
        {
            string connString = ConfigurationManager.ConnectionStrings["FileStreamDB"].ConnectionString;
            using (SqlConnection connection = new SqlConnection(connString))
            {
                connection.Open();

                SqlTransaction tran = connection.BeginTransaction(
                    System.Data.IsolationLevel.ReadCommitted);

                SqlCommand command = new SqlCommand("", connection);
                command.CommandText = @"
                INSERT INTO dbo.student
                OUTPUT Inserted.Resume.PathName(), GET_FILESTREAM_TRANSACTION_CONTEXT()
                VALUES (newid (), 'Mary', CAST ('' as varbinary(max)))";
                command.Transaction = tran;

                using (SqlDataReader reader = command.ExecuteReader())
                {
                    reader.Read();
                    // Get the pointer for file
                    string path = reader.GetString(0);
                    byte[] transactionContext = reader.GetSqlBytes(1).Buffer;

                    using (Stream fileStream = new SqlFileStream(path,
                        (byte[])reader.GetValue(1),
                        FileAccess.Write,
                        FileOptions.None, 0))
                    {

                        // Hardcode the stream
                        byte[] contentToWrite = new byte[4096];

                        /*
                        contentToWrite[0] = (byte)'R';
                        contentToWrite[1] = (byte)'e';
                        contentToWrite[2] = (byte)'s';
                        contentToWrite[3] = (byte)'u';
                        contentToWrite[4] = (byte)'m';
                        contentToWrite[5] = (byte)'e';
                         */

                        contentToWrite = Encoding.ASCII.GetBytes("Resume");

                        fileStream.Write(contentToWrite, 0, 6);
                        fileStream.Close();
                    }
                }
                tran.Commit();
            }
        }
    }
}
